package com.gavin.function;

import java.text.Collator;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import com.yindangu.v3.business.plugin.business.api.func.IFuncContext;
import com.yindangu.v3.business.plugin.business.api.func.IFuncOutputVo;
import com.yindangu.v3.business.plugin.business.api.func.IFunction;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 测试验证-后端函数
 * @author huangjr
 * @since 2021-06-03
 */
public class GavinTestFunction implements IFunction {

    private Logger logger = LoggerFactory.getLogger(GavinTestFunction.class);

    private final static int SIZE_PARAMS = 3;

    @Override
    public IFuncOutputVo evaluate(IFuncContext context) {
        //  函数返回值对象
        IFuncOutputVo outputVo = context.newOutputVo();
        //  函数参数个数
        int paramSize = context.getInputSize();
                        
        if (paramSize < SIZE_PARAMS) {
            outputVo.put(null);
            return outputVo;
        }

        String one = (String) context.getInput(0);
        String two = (String) context.getInput(1);
        String three = (String) context.getInput(2);

        List<String> lst = new ArrayList<String>();
        lst.add(one);
        lst.add(two);
        lst.add(three);

        Comparator<Object> com = Collator.getInstance(java.util.Locale.CHINA);                  
        Collections.sort(lst, com); 

        StringBuffer sb = new StringBuffer("");
        for (String str : lst) {
            if (sb.length() > 0) {
                sb.append(",");
            }
            sb.append(str);
        }
        outputVo.put(sb.toString());
        logger.info(">>>输入参数1:" + one + ",输入参数2:" + two + ",输入参数3:" + three + "<<<");
        logger.info(">>>输出参数:" + sb.toString() + "<<<");
        return outputVo;
    }
    
}